import torch
from torch.utils.data import TensorDataset
import torchvision.datasets as datasets
from torchvision import transforms
import numpy as np
import matplotlib.pyplot as plt
import collections
from tqdm import tqdm
import pdb
from torch.utils.data import Dataset

class CELEBA(Dataset):
    def __init__(self,train=True,random=False):
        transform = transforms.Compose([
        # transforms.Scale(image_size),
        # transforms.Resize(image_size),
        transforms.ToTensor(),
        transforms.Normalize((0.5, 0.5, 0.5), (0.5, 0.5, 0.5))
])
        split = 'train' if train else 'test'
        self.dataset = datasets.CelebA(root='../../data', split=split, download=True, transform=transform)
        self.random = random

    def __getitem__(self,idx):
        img, attr = self.dataset.__getitem__(idx)
        if self.random:
            i = np.random.choice([100,200,300,400,500],1)
            i = 500
            pick = np.random.choice(218*178,i,replace=False)
            mask = np.zeros(218*178,dtype=np.float32)
            mask[pick] = 1
            mask = mask.reshape(218,178)[None,:,:]
            img = img*mask
        return img,attr
        pdb.set_trace()
        size_1 = 218
        size_2 = 178
        x = [[int(i/size_2)/size_1,(i%size_2)/size_2] for i in range(size_1*size_2)]
        x = torch.from_numpy(np.array(x))
        x = x.type(torch.FloatTensor)
        
        img = img.permute([1,2,0]).contiguous()
        y = img.view(-1,3)
        return x,y,attr
    def __len__(self):
        return len(self.dataset)


if __name__=='__main__':
    dataset = CELEBA(True,False)
    img, _ = dataset.__getitem__(0)
    plt.imshow((img.permute([1,2,0])+1)/2)
    plt.savefig('images/no_interpolate.png')
    plt.close()
    pdb.set_trace()
