import torch
from torch.utils.data import TensorDataset
import torchvision.datasets as datasets
import numpy as np
import matplotlib.pyplot as plt
import collections
from tqdm import tqdm
import pdb
import numpy as np


def KMNISTSET(train=True):
    dataset = datasets.KMNIST(root='../data', train=train, download=True, transform=None)
    data = dataset.data
    
    x = [[int(i/28)/28,(i%28)/28] for i in range(28*28)]
    x = torch.from_numpy(np.array(x))
    x = x.unsqueeze(0)
    x = x.repeat(data.shape[0],1,1)
    x = x.type(torch.FloatTensor)
    
    y = data.view(data.shape[0],-1,1).type(torch.FloatTensor)/255.0
    return TensorDataset(x.detach(),y.detach())

def plot(target_x, target_y, context_x, context_y, pred_y, var, it, model_name):

    target_x, target_y, context_x, context_y, pred_y, var \
      = target_x[0].to('cpu').data, target_y[0].to('cpu').data, context_x[0].to('cpu').data, context_y[0].to('cpu').data, pred_y[0].to('cpu').data, var[0].to('cpu').data
    target_y = target_y.view([28,28])
    pred_y = pred_y.view([28,28])
    var = var.view([28,28])

    plt.imshow(target_y,cmap='gray',vmin=0,vmax=1)
    plt.savefig('images/%s%d_target.png'%(model_name,it))
    plt.close()


    plt.imshow(pred_y,cmap='gray',vmin=0,vmax=1)
    plt.savefig('images/%s%d_pred.png'%(model_name,it))
    plt.close()

    plt.imshow(var,cmap='gray',vmin=var.min(),vmax=var.max())
    plt.savefig('images/%s%d_var.png'%(model_name,it))
    plt.close()

    pdb.set_trace()

if __name__=='__main__':
    KMNISTSET()
